/* KallistiGL for KOS 1.1.6

   glinternal.c
   (c)2001 Dan Potter

*/

#ifndef __GL_GLINTERNAL_H
#define __GL_GLINTERNAL_H

/* Implementation details; not to be used externally */
#include <GL/gl.h>
#include <dc/ta.h>
#include <dcutils/3dutils.h>

/* Texture data	structure -- whenever you call glBindTexture(), gl_cur_texture
   will be set to point to one of these. */
typedef struct gl_texture_int {
	poly_hdr_t	pbuf_opaque;	/* Opaque header */
	poly_hdr_t	pbuf_trans;	/* Translucent header */
} gl_texture_int_t;

/* "Clear color" -- really the background plane color */
extern GLfloat gl_clear_color[4];

/* Capability mask (for glEnable() and glDisable()) */
extern GLbitfield gl_capabilities;

/* Enabled lists (PVR specific) */
extern GLbitfield gl_enabled_lists;

/* Current primitive type (GL_TRIANGLES, etc) */
extern GLenum gl_prim_type;

/* Poly header buffer submitted? */
extern GLboolean gl_pbuf_submitted;

/* A "null" texture for when we're not texturing */
extern gl_texture_int_t gl_null_texture;

/* Currently selected texture */
extern gl_texture_int_t *gl_cur_texture;

/* Viewport size */
extern GLint gl_viewport_x1, gl_viewport_y1,
	gl_viewport_width, gl_viewport_height;

/* Transformation matrices; possibilities are:
   GL_MODELVIEW
   GL_PROJECTION
   GL_TEXTURE
*/
extern matrix_t gl_trans_mats[GL_MATRIX_COUNT]  __attribute__((aligned(32)));
extern int gl_matrix_mode;
extern GLboolean gl_matrix_dirty;

/* Some happy macros */
#define TXR_ENABLED (gl_capabilities & GL_TEXTURE_2D)
#define AUTOUV_ENABLED (gl_capabilities & GL_KOS_AUTO_UV)

/* Currently active list */
extern GLbitfield gl_active_list;

/* Face culling enabled/disabled */
extern GLboolean gl_cull_face;

/* Culling mode */
extern GLenum gl_cull_mode;

#endif	/* __GL_GLINTERNAL_H */

